/*
 * App Global CSS
 * ----------------------------------------------------------------------------
 * Put style rules here that you want to apply globally. These styles are for
 * the entire app and not just one component. Additionally, this file can be
 * used as an entry point to import other CSS/Sass files to be included in the
 * output CSS.
 * For more information on global stylesheets, visit the documentation:
 * https://ionicframework.com/docs/layout/global-stylesheets
 */
/* Core CSS required for Ionic components to work properly */

@import '~@ionic/angular/css/core.css';
/* Basic CSS for apps built with Ionic */

@import '~@ionic/angular/css/normalize.css';
@import '~@ionic/angular/css/structure.css';
@import '~@ionic/angular/css/typography.css';
@import '~@ionic/angular/css/display.css';

/* Optional CSS utils that can be commented out */

@import '~@ionic/angular/css/padding.css';
@import '~@ionic/angular/css/float-elements.css';
@import '~@ionic/angular/css/text-alignment.css';
@import '~@ionic/angular/css/text-transformation.css';
@import '~@ionic/angular/css/flex-utils.css';

@import './theme/variables.scss';

$text-primary: 'Roboto', sans-serif;
$text-secondary: 'Raleway', sans-serif;

$fonts: (
    'primary': --ion-text-primary,
    'secondary': --ion-text-secondary
);
$colors: 'primary', 'green', 'green-dark', 'green-light', 'secondary',
    'tertiary', 'warning', 'success', 'danger', 'medium', 'light', 'dark',
    'dark-medium', 'dove-dark', 'black-light', 'dark-light', 'black', 'white',
    'white-dove', 'primary-dark', 'blue', 'blue-light', 'gray', 'silver', 'grey',
    'grey-dark', 'dove-grey', 'light-gray', 'primary-fade', 'pale-grey-thin',
    'pale-grey', 'pale-stone', 'sea-green', 'silver', 'grey-light', 'grey-black',
    'grey-black-thin', 'pink', 'primary-light', 'dove-gray', 'dove-black',
    'dove-light', 'bright-red', 'pale-grey-light', 'green-light-thin', 'red',
    'pale-grey-dark', 'tundora', 'alto', 'blue-pale', 'green-dove',
    'grey-lighter', 'grey-thin', 'grey-light-thin', 'blue-misty', 'gray-slate',
    'dark-thin', 'dark-light-thin', 'white-light', 'white-pale', 'alert',
    'danger-light', 'grey-slate', 'dove-grey-light', 'whisper-grey', 'neutral',
    'blue-dark', 'lime-green', 'lime-green-dark', 'spring-green', 'grey-fade',
    'grey-dark-lighter', 'fern', 'blue-light';

html,
body {
    font-family: var(--ion-text-primary);
}

h1 {
    font-size: 1.25em;
}
h2 {
    font-size: 1.125em;
}
h3 {
    font-size: 1em;
}
h4 {
    font-size: 0.875em;
}
h5 {
    font-size: 0.75em;
}
h6 {
    font-size: 0.625em;
}
//generic customized css
// fonts : weight-500
$font-weight: 100, 200, 300, 400, 500, 600, 700, 800;
@each $i in $font-weight {
    .weight-#{$i} {
        font-weight: $i;
        & ion-button {
            font-weight: $i;
        }
    }
}

//typography
@each $font-name, $font-value in $fonts {
    .text-#{$font-name},
    .has-text-#{$font-name} {
        font-family: var(#{$font-value});
    }
}

//width and height

$maxvalue: 400;
@for $i from 0 through $maxvalue {
    .width-#{$i} {
        width: #{$i}px;
    }
    .height-#{$i} {
        height: #{$i}px;
    }
}

// border-width and spacing
$maxsize: 100;
@for $i from 0 through $maxsize {
    .size-#{$i} {
        font-size: #{$i}px;
    }
    .border-#{$i} {
        border-width: #{$i}px;
    }
    .border-top-#{$i} {
        border-top-width: #{$i}px;
    }
    .border-left-#{$i} {
        border-left-width: #{$i}px;
    }
    .border-right-#{$i} {
        border-right-width: #{$i}px;
    }
    .border-bottom-#{$i} {
        border-bottom-width: #{$i}px;
    }
    .mt-#{$i} {
        margin-top: #{$i}px;
    }
    .mb-#{$i} {
        margin-bottom: #{$i}px;
    }
    .ml-#{$i} {
        margin-left: #{$i}px;
    }
    .mr-#{$i} {
        margin-right: #{$i}px;
    }
    .mx-#{$i} {
        margin-right: #{$i}px;
        margin-left: #{$i}px;
    }
    .my-#{$i} {
        margin-top: #{$i}px;
        margin-bottom: #{$i}px;
    }
    .m-#{$i} {
        margin-top: #{$i}px;
        margin-bottom: #{$i}px;
        margin-right: #{$i}px;
        margin-left: #{$i}px;
    }
    .pt-#{$i} {
        padding-top: #{$i}px;
    }
    .pb-#{$i} {
        padding-bottom: #{$i}px;
    }
    .pl-#{$i} {
        padding-left: #{$i}px;
    }
    .pr-#{$i} {
        padding-right: #{$i}px;
    }
    .px-#{$i} {
        padding-right: #{$i}px;
        padding-left: #{$i}px;
    }
    .py-#{$i} {
        padding-top: #{$i}px;
        padding-bottom: #{$i}px;
    }
    .p-#{$i} {
        padding-top: #{$i}px;
        padding-bottom: #{$i}px;
        padding-right: #{$i}px;
        padding-left: #{$i}px;
    }
}

.ion-text-underline {
    text-decoration: underline;
}

$borderTypes: solid, dashed, dotted; // Replace with your desired border styles

@each $borderType in $borderTypes {
    .border-#{$borderType} {
        border-style: $borderType;
    }
}

//colors custom styles
@each $color in $colors {
    .has-border-#{$color} {
        border-color: var(--ion-color-#{$color});
    }
    .border-top-#{$color} {
        border-top-color: var(--ion-color-#{$color});
    }
    .border-left-#{$color} {
        border-left-color: var(--ion-color-#{$color});
    }
    .border-right-#{$color} {
        border-right-color: var(--ion-color-#{$color});
    }
    .border-bottom-#{$color} {
        border-bottom-color: var(--ion-color-#{$color});
    }
    .has-background-#{$color} {
        background-color: var(--ion-color-#{$color});
    }
    .is-#{$color} {
        color: var(--ion-color-#{$color});
    }
    .indicator-color-#{$color} {
        --indicator-color: var(--ion-color-#{$color});
    }
}

// rounded
$maxrounded: 200;
@for $i from 0 through $maxrounded {
    .button--radius-#{$i} {
        & ion-button {
            --border-radius: #{$i}px;
        }
    }
    .radius-#{$i} {
        border-radius: #{$i}px;
    }
    .radius-tl-#{$i} {
        border-top-left-radius: #{$i}px;
    }
    .radius-tr-#{$i} {
        border-top-right-radius: #{$i}px;
    }
    .radius-bl-#{$i} {
        border-bottom-left-radius: #{$i}px;
    }
    .radius-br-#{$i} {
        border-bottom-right-radius: #{$i}px;
    }
}

.ion-input {
    border: solid var(--ion-color-medium) 1px;
    border-radius: 5px;
    height: 35px;
}
a {
    text-decoration: none;
}

$display-types: block, flex, inline, inline-block, inline-flex;

@each $type in $display-types {
    .#{$type} {
        display: $type;
    }
}

ion-button {
    font-size: inherit;
    color: inherit;
    margin: inherit;
}

ion-avatar {
    overflow: hidden;
}
